﻿
--===================================================
--									
--										GHI Main
--									ghi_main.lua
--
--								Main setup file
--	
-- 						(c)2011 The Gryphonheart Team
--								All rights reservated
--===================================================	

local class
function GHI_Main()
	if class then
		return class
	end
	class = GHClass("GHI_Main")

	local slashCmd,ghiPing,trade,itemUpdater,options,log;
	
	local function SetUpOnGHILoaded()
	
		-- remember, only set up the classes that are really needed to run all the time
	
		slashCmd = GHI_SlashCmd("GHI"); -- need to run to listen for chat commands
		ghiPing = GHI_Ping(); -- needs to run to reply to other pings
		
		slashCmd.SetDefaultFunc(function(x) GHI_ToggleBackpack(); end);
		slashCmd.RegisterSubPrefix("ping",ghiPing.SendPing);
		slashCmd.RegisterSubPrefix("reload",function(x) GHI_ReloadUI() end);
		
		GHI_Message(GHI_LOADED);
		log = GHI_Log();
		log.Add(3,GHI_LOADED);
		
	end
	
	local function SetUpOnTradeFrameShown()
		trade = GHI_Trade();
	end
	
	
	local function SetUpOnVariablesLoaded()
		itemUpdater = GHI_ItemUpdater()
		itemUpdater.UpdateAllItems();
		
		options = GHI_OptionsMenu()
        GHI_UnitTooltip();
	end
	
	-- Let SetUp run when GHI is loaded
	local f = CreateFrame("frame");
	f:SetScript("OnEvent",function(self,event,addon) -- These events should later on be set up by calling an event handler class
		if event == "ADDON_LOADED" then
			if addon == "GHI" then SetUpOnGHILoaded(); end
		elseif event == "TRADE_SHOW" then
			SetUpOnTradeFrameShown()
		elseif event == "VARIABLES_LOADED" then
			SetUpOnVariablesLoaded();
		end
	end);
	f:RegisterEvent("ADDON_LOADED");
	f:RegisterEvent("TRADE_SHOW");
	f:RegisterEvent("VARIABLES_LOADED");
	
	return class;

end
GHI_Main();
GHI_Main = nil;







